org.apache.hc.core5.http.nio.support

## Class BasicPushProducer

- java.lang.Object
- - org.apache.hc.core5.http.nio.support.BasicPushProducer

- All Implemented Interfaces:
    AsyncDataProducer, AsyncPushProducer, ResourceHolder

      public class BasicPushProducer
      extends Object
      implements AsyncPushProducer

  Basic implementation of `AsyncPushProducer` that produces one fixed response and relies on a `AsyncEntityProducer` to generate response entity stream.
  Since:
    5.0

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `BasicPushProducer(AsyncEntityProducer dataProducer)`
    `BasicPushProducer(HttpResponse response, AsyncEntityProducer dataProducer)`
    `BasicPushProducer(int code, AsyncEntityProducer dataProducer)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `available()` Returns the number of bytes immediately available for output.
    `void` | `failed(Exception cause)` Triggered to signal a failure in data generation.
    `void` | `produce(DataStreamChannel channel)` Triggered to signal the ability of the underlying data channel to accept more data.
    `void` | `produceResponse(ResponseChannel channel, HttpContext httpContext)` Triggered to signal the ability of the underlying response channel to accept response messages.
    `void` | `releaseResources()`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### BasicPushProducer

          public BasicPushProducer(HttpResponse response,
                           AsyncEntityProducer dataProducer)

    - #### BasicPushProducer

          public BasicPushProducer(int code,
                           AsyncEntityProducer dataProducer)

    - #### BasicPushProducer

          public BasicPushProducer(AsyncEntityProducer dataProducer)

  - ### Method Detail

    - #### produceResponse

          public void produceResponse(ResponseChannel channel,
                             HttpContext httpContext)
                               throws HttpException,
                                      IOException

      Description copied from interface: `AsyncPushProducer`
      Triggered to signal the ability of the underlying response channel to accept response messages. The data producer can choose to send a final response message immediately inside the call or asynchronously at some later point. The final response can be preceded by a number of intermediate messages.
      Specified by:
        `produceResponse` in interface `AsyncPushProducer`
      Parameters:
        `channel` - the response channel capable to accepting response messages.
        `httpContext` - the actual execution context.
      Throws:
        `HttpException`
        `IOException`

    - #### available

          public int available()

      Description copied from interface: `AsyncDataProducer`
      Returns the number of bytes immediately available for output. This method can be used as a hint to control output events of the underlying I/O session.
      Specified by:
        `available` in interface `AsyncDataProducer`
      Returns:
        the number of bytes immediately available for output

    - #### produce

          public void produce(DataStreamChannel channel)
                       throws IOException

      Description copied from interface: `AsyncDataProducer`
      Triggered to signal the ability of the underlying data channel to accept more data. The data producer can choose to write data immediately inside the call or asynchronously at some later point.
      Specified by:
        `produce` in interface `AsyncDataProducer`
      Parameters:
        `channel` - the data channel capable to accepting more data.
      Throws:
        `IOException`

    - #### failed

          public void failed(Exception cause)

      Description copied from interface: `AsyncPushProducer`
      Triggered to signal a failure in data generation.
      Specified by:
        `failed` in interface `AsyncPushProducer`
      Parameters:
        `cause` - the cause of the failure.

    - #### releaseResources

          public void releaseResources()

      Specified by:
        `releaseResources` in interface `ResourceHolder`

Copyright © 2005–2021 The Apache Software Foundation. All rights reserved.